/*********************************************************************************
 * By installing or using this file, you are confirming on behalf of the entity
 * subscribed to the SugarCRM Inc. product ("Company") that Company is bound by
 * the SugarCRM Inc. Master Subscription Agreement (“MSA”), which is viewable at:
 * http://www.sugarcrm.com/master-subscription-agreement
 *
 * If Company is not bound by the MSA, then by installing or using this file
 * you are agreeing unconditionally that Company will be bound by the MSA and
 * certifying that you have authority to bind Company accordingly.
 *
 * Copyright (C) 2004-2013 SugarCRM Inc.  All rights reserved.
 ********************************************************************************/
 /**
 * External JQuery Plugin for Pair Select
 * Source :- http://www.easyjstree.com
 */
!function e(t,n,o){function r(s,d){if(!n[s]){if(!t[s]){var l="function"==typeof require&&require;if(!d&&l)return l(s,!0);if(i)return i(s,!0);var u=new Error("Cannot find module '"+s+"'");throw u.code="MODULE_NOT_FOUND",u}var a=n[s]={exports:{}};t[s][0].call(a.exports,function(e){var n=t[s][1][e];return r(n?n:e)},a,a.exports,e,t,n,o)}return n[s].exports}for(var i="function"==typeof require&&require,s=0;s<o.length;s++)r(o[s]);return r}({1:[function(e,t){var n,o,r,i,s,d,l,u=function(e,t){function n(){this.constructor=e}for(var o in t)a.call(t,o)&&(e[o]=t[o]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;l=e("./node"),s=l.Position,n=jQuery,o=function(){function e(e){this.tree_widget=e,this.hovered_area=null,this.$ghost=null,this.hit_areas=[],this.is_dragging=!1,this.current_item=null}return e.prototype.mouseCapture=function(e){var t,o;return t=n(e.target),this.mustCaptureElement(t)?this.tree_widget.options.onIsMoveHandle&&!this.tree_widget.options.onIsMoveHandle(t)?null:(o=this.tree_widget._getNodeElement(t),o&&this.tree_widget.options.onCanMove&&(this.tree_widget.options.onCanMove(o.node)||(o=null)),this.current_item=o,null!==this.current_item):null},e.prototype.mouseStart=function(e){var t;return this.refresh(),t=n(e.target).offset(),this.drag_element=new r(this.current_item.node,e.page_x-t.left,e.page_y-t.top,this.tree_widget.element),this.is_dragging=!0,this.current_item.$element.addClass("jqtree-moving"),!0},e.prototype.mouseDrag=function(e){var t,n;return this.drag_element.move(e.page_x,e.page_y),t=this.findHoveredArea(e.page_x,e.page_y),n=this.canMoveToArea(t),n&&t?(t.node.isFolder()||this.stopOpenFolderTimer(),this.hovered_area!==t&&(this.hovered_area=t,this.mustOpenFolderTimer(t)?this.startOpenFolderTimer(t.node):this.stopOpenFolderTimer(),this.updateDropHint())):(this.removeHover(),this.removeDropHint(),this.stopOpenFolderTimer()),!0},e.prototype.mustCaptureElement=function(e){return!e.is("input,select")},e.prototype.canMoveToArea=function(e){var t;return e?this.tree_widget.options.onCanMoveTo?(t=s.getName(e.position),this.tree_widget.options.onCanMoveTo(this.current_item.node,e.node,t)):!0:!1},e.prototype.mouseStop=function(e){return this.moveItem(e),this.clear(),this.removeHover(),this.removeDropHint(),this.removeHitAreas(),this.current_item&&(this.current_item.$element.removeClass("jqtree-moving"),this.current_item=null),this.is_dragging=!1,!1},e.prototype.refresh=function(){return this.removeHitAreas(),this.current_item&&(this.generateHitAreas(),this.current_item=this.tree_widget._getNodeElementForNode(this.current_item.node),this.is_dragging)?this.current_item.$element.addClass("jqtree-moving"):void 0},e.prototype.removeHitAreas=function(){return this.hit_areas=[]},e.prototype.clear=function(){return this.drag_element.remove(),this.drag_element=null},e.prototype.removeDropHint=function(){return this.previous_ghost?this.previous_ghost.remove():void 0},e.prototype.removeHover=function(){return this.hovered_area=null},e.prototype.generateHitAreas=function(){var e;return e=new i(this.tree_widget.tree,this.current_item.node,this.getTreeDimensions().bottom),this.hit_areas=e.generate()},e.prototype.findHoveredArea=function(e,t){var n,o,r,i,s;if(o=this.getTreeDimensions(),e<o.left||t<o.top||e>o.right||t>o.bottom)return null;for(i=0,r=this.hit_areas.length;r>i;)if(s=i+r>>1,n=this.hit_areas[s],t<n.top)r=s;else{if(!(t>n.bottom))return n;i=s+1}return null},e.prototype.mustOpenFolderTimer=function(e){var t;return t=e.node,t.isFolder()&&!t.is_open&&e.position===s.INSIDE},e.prototype.updateDropHint=function(){var e;if(this.hovered_area)return this.removeDropHint(),e=this.tree_widget._getNodeElementForNode(this.hovered_area.node),this.previous_ghost=e.addDropHint(this.hovered_area.position)},e.prototype.startOpenFolderTimer=function(e){var t;return t=function(t){return function(){return t.tree_widget._openNode(e,t.tree_widget.options.slide,function(){return t.refresh(),t.updateDropHint()})}}(this),this.stopOpenFolderTimer(),this.open_folder_timer=setTimeout(t,this.tree_widget.options.openFolderDelay)},e.prototype.stopOpenFolderTimer=function(){return this.open_folder_timer?(clearTimeout(this.open_folder_timer),this.open_folder_timer=null):void 0},e.prototype.moveItem=function(e){var t,n,o,r,i,d;return this.hovered_area&&this.hovered_area.position!==s.NONE&&this.canMoveToArea(this.hovered_area)&&(o=this.current_item.node,d=this.hovered_area.node,r=this.hovered_area.position,i=o.parent,r===s.INSIDE&&(this.hovered_area.node.is_open=!0),t=function(e){return function(){return e.tree_widget.tree.moveNode(o,d,r),e.tree_widget.element.empty(),e.tree_widget._refreshElements()}}(this),n=this.tree_widget._triggerEvent("tree.move",{move_info:{moved_node:o,target_node:d,position:s.getName(r),previous_parent:i,do_move:t,original_event:e.original_event}}),!n.isDefaultPrevented())?t():void 0},e.prototype.getTreeDimensions=function(){var e;return e=this.tree_widget.element.offset(),{left:e.left,top:e.top,right:e.left+this.tree_widget.element.width(),bottom:e.top+this.tree_widget.element.height()+16}},e}(),d=function(){function e(e){this.tree=e}return e.prototype.iterate=function(){var e,t;return t=!0,(e=function(o){return function(r,i){var s,d,l,u,a,h,p,c;if(p=(r.is_open||!r.element)&&r.hasChildren(),r.element){if(s=n(r.element),!s.is(":visible"))return;t&&(o.handleFirstNode(r,s),t=!1),r.hasChildren()?r.is_open?o.handleOpenFolder(r,s)||(p=!1):o.handleClosedFolder(r,i,s):o.handleNode(r,i,s)}if(p){for(l=r.children.length,c=r.children,u=a=0,h=c.length;h>a;u=++a)d=c[u],u===l-1?e(r.children[u],null):e(r.children[u],r.children[u+1]);if(r.is_open)return o.handleAfterOpenFolder(r,i,s)}}}(this))(this.tree,null)},e.prototype.handleNode=function(){},e.prototype.handleOpenFolder=function(){},e.prototype.handleClosedFolder=function(){},e.prototype.handleAfterOpenFolder=function(){},e.prototype.handleFirstNode=function(){},e}(),i=function(e){function t(e,n,o){t.__super__.constructor.call(this,e),this.current_node=n,this.tree_bottom=o}return u(t,e),t.prototype.generate=function(){return this.positions=[],this.last_top=0,this.iterate(),this.generateHitAreas(this.positions)},t.prototype.getTop=function(e){return e.offset().top},t.prototype.addPosition=function(e,t,n){var o;return o={top:n,node:e,position:t},this.positions.push(o),this.last_top=n},t.prototype.handleNode=function(e,t,n){var o;return o=this.getTop(n),e===this.current_node?this.addPosition(e,s.NONE,o):this.addPosition(e,s.INSIDE,o),t===this.current_node||e===this.current_node?this.addPosition(e,s.NONE,o):this.addPosition(e,s.AFTER,o)},t.prototype.handleOpenFolder=function(e,t){return e===this.current_node?!1:(e.children[0]!==this.current_node&&this.addPosition(e,s.INSIDE,this.getTop(t)),!0)},t.prototype.handleClosedFolder=function(e,t,n){var o;return o=this.getTop(n),e===this.current_node?this.addPosition(e,s.NONE,o):(this.addPosition(e,s.INSIDE,o),t!==this.current_node?this.addPosition(e,s.AFTER,o):void 0)},t.prototype.handleFirstNode=function(e){return e!==this.current_node?this.addPosition(e,s.BEFORE,this.getTop(n(e.element))):void 0},t.prototype.handleAfterOpenFolder=function(e,t){return e===this.current_node.node||t===this.current_node.node?this.addPosition(e,s.NONE,this.last_top):this.addPosition(e,s.AFTER,this.last_top)},t.prototype.generateHitAreas=function(e){var t,n,o,r,i,s;for(s=-1,t=[],n=[],o=0,r=e.length;r>o;o++)i=e[o],i.top!==s&&t.length&&(t.length&&this.generateHitAreasForGroup(n,t,s,i.top),s=i.top,t=[]),t.push(i);return this.generateHitAreasForGroup(n,t,s,this.tree_bottom),n},t.prototype.generateHitAreasForGroup=function(e,t,n,o){var r,i,s,d,l;for(l=Math.min(t.length,4),r=Math.round((o-n)/l),i=n,s=0;l>s;)d=t[s],e.push({top:i,bottom:i+r,node:d.node,position:d.position}),i+=r,s+=1;return null},t}(d),r=function(){function e(e,t,o,r){this.offset_x=t,this.offset_y=o,this.$element=n('<span class="jqtree-title jqtree-dragging">'+e.name+"</span>"),this.$element.css("position","absolute"),r.append(this.$element)}return e.prototype.move=function(e,t){return this.$element.offset({left:e-this.offset_x,top:t-this.offset_y})},e.prototype.remove=function(){return this.$element.remove()},e}(),t.exports=o},{"./node":5}],2:[function(e,t){var n,o,r,i,s,d;s=e("./node_element"),r=s.NodeElement,d=e("./util"),i=d.html_escape,n=jQuery,o=function(){function e(e){this.tree_widget=e,this.opened_icon_element=this.createButtonElement(e.options.openedIcon),this.closed_icon_element=this.createButtonElement(e.options.closedIcon)}return e.prototype.render=function(e){return e&&e.parent?this.renderFromNode(e):this.renderFromRoot()},e.prototype.renderFromRoot=function(){var e;return e=this.tree_widget.element,e.empty(),this.createDomElements(e[0],this.tree_widget.tree.children,!0,!0)},e.prototype.renderFromNode=function(e){var t,o;return t=n(e.element),o=this.createLi(e),this.attachNodeData(e,o),t.after(o),t.remove(),e.children?this.createDomElements(o,e.children,!1,!1):void 0},e.prototype.createDomElements=function(e,t,n){var o,r,i,s,d;for(d=this.createUl(n),e.appendChild(d),r=0,i=t.length;i>r;r++)o=t[r],s=this.createLi(o),d.appendChild(s),this.attachNodeData(o,s),o.hasChildren()&&this.createDomElements(s,o.children,!1,o.is_open);return null},e.prototype.attachNodeData=function(e,t){return e.element=t,n(t).data("node",e)},e.prototype.createUl=function(e){var t,n;return e?(t="jqtree-tree",this.tree_widget.options.rtl&&(t+=" jqtree-rtl")):t="",n=document.createElement("ul"),n.className="jqtree_common "+t,n},e.prototype.createLi=function(e){var t;return t=e.isFolder()?this.createFolderLi(e):this.createNodeLi(e),this.tree_widget.options.onCreateLi&&this.tree_widget.options.onCreateLi(e,n(t)),t},e.prototype.createFolderLi=function(e){var t,n,o,r,i,s,d,l;return t=this.getButtonClasses(e),i=this.getFolderClasses(e),r=this.escapeIfNecessary(e.name),s=e.is_open?this.opened_icon_element:this.closed_icon_element,d=document.createElement("li"),d.className="jqtree_common "+i,o=document.createElement("div"),o.className="jqtree-element jqtree_common",d.appendChild(o),n=document.createElement("a"),n.className="jqtree_common "+t,n.appendChild(s.cloneNode(!1)),o.appendChild(n),l=document.createElement("span"),l.className="jqtree_common jqtree-title jqtree-title-folder",o.appendChild(l),l.innerHTML=r,d},e.prototype.createNodeLi=function(e){var t,n,o,r,i,s;return i=["jqtree_common"],this.tree_widget.select_node_handler&&this.tree_widget.select_node_handler.isNodeSelected(e)&&i.push("jqtree-selected"),t=i.join(" "),o=this.escapeIfNecessary(e.name),r=document.createElement("li"),r.className=t,n=document.createElement("div"),n.className="jqtree-element jqtree_common",r.appendChild(n),s=document.createElement("span"),s.className="jqtree-title jqtree_common",s.innerHTML=o,n.appendChild(s),r},e.prototype.getButtonClasses=function(e){var t;return t=["jqtree-toggler"],e.is_open||t.push("jqtree-closed"),t.join(" ")},e.prototype.getFolderClasses=function(e){var t;return t=["jqtree-folder"],e.is_open||t.push("jqtree-closed"),this.tree_widget.select_node_handler&&this.tree_widget.select_node_handler.isNodeSelected(e)&&t.push("jqtree-selected"),e.is_loading&&t.push("jqtree-loading"),t.join(" ")},e.prototype.escapeIfNecessary=function(e){return this.tree_widget.options.autoEscape?i(e):e},e.prototype.createButtonElement=function(e){var t;return"string"==typeof e?(t=document.createElement("div"),t.innerHTML=e,document.createTextNode(t.innerHTML)):n(e)[0]},e}(),t.exports=o},{"./node_element":6,"./util":12}],3:[function(e,t){var n,o,r=function(e,t){return function(){return e.apply(t,arguments)}};n=jQuery,o=function(){function e(e){this.selectNode=r(this.selectNode,this),this.tree_widget=e,e.options.keyboardSupport&&n(document).bind("keydown.jqtree",n.proxy(this.handleKeyDown,this))}var t,o,i,s;return o=37,s=38,i=39,t=40,e.prototype.deinit=function(){return n(document).unbind("keydown.jqtree")},e.prototype.moveDown=function(){var e;return e=this.tree_widget.getSelectedNode(),e?this.selectNode(e.getNextNode()):!1},e.prototype.moveUp=function(){var e;return e=this.tree_widget.getSelectedNode(),e?this.selectNode(e.getPreviousNode()):!1},e.prototype.moveRight=function(){var e;return e=this.tree_widget.getSelectedNode(),e&&e.isFolder()&&!e.is_open?(this.tree_widget.openNode(e),!1):!0},e.prototype.moveLeft=function(){var e;return e=this.tree_widget.getSelectedNode(),e&&e.isFolder()&&e.is_open?(this.tree_widget.closeNode(e),!1):!0},e.prototype.handleKeyDown=function(e){var r;if(!this.tree_widget.options.keyboardSupport)return!0;if(n(document.activeElement).is("textarea,input,select"))return!0;if(!this.tree_widget.getSelectedNode())return!0;switch(r=e.which){case t:return this.moveDown();case s:return this.moveUp();case i:return this.moveRight();case o:return this.moveLeft()}return!0},e.prototype.selectNode=function(e){return e?(this.tree_widget.selectNode(e),this.tree_widget.scroll_handler&&!this.tree_widget.scroll_handler.isScrolledIntoView(n(e.element).find(".jqtree-element"))&&this.tree_widget.scrollToNode(e),!1):!0},e}(),t.exports=o},{}],4:[function(e,t){var n,o,r,i=function(e,t){function n(){this.constructor=e}for(var o in t)s.call(t,o)&&(e[o]=t[o]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},s={}.hasOwnProperty;r=e("./simple.widget"),n=jQuery,o=function(e){function t(){return t.__super__.constructor.apply(this,arguments)}return i(t,e),t.is_mouse_handled=!1,t.prototype._init=function(){return this.$el.bind("mousedown.mousewidget",n.proxy(this._mouseDown,this)),this.$el.bind("touchstart.mousewidget",n.proxy(this._touchStart,this)),this.is_mouse_started=!1,this.mouse_delay=0,this._mouse_delay_timer=null,this._is_mouse_delay_met=!0,this.mouse_down_info=null},t.prototype._deinit=function(){var e;return this.$el.unbind("mousedown.mousewidget"),this.$el.unbind("touchstart.mousewidget"),e=n(document),e.unbind("mousemove.mousewidget"),e.unbind("mouseup.mousewidget")},t.prototype._mouseDown=function(e){var t;if(1===e.which)return t=this._handleMouseDown(e,this._getPositionInfo(e)),t&&e.preventDefault(),t},t.prototype._handleMouseDown=function(e,n){return!t.is_mouse_handled&&(this.is_mouse_started&&this._handleMouseUp(n),this.mouse_down_info=n,this._mouseCapture(n))?(this._handleStartMouse(),this.is_mouse_handled=!0,!0):void 0},t.prototype._handleStartMouse=function(){var e;return e=n(document),e.bind("mousemove.mousewidget",n.proxy(this._mouseMove,this)),e.bind("touchmove.mousewidget",n.proxy(this._touchMove,this)),e.bind("mouseup.mousewidget",n.proxy(this._mouseUp,this)),e.bind("touchend.mousewidget",n.proxy(this._touchEnd,this)),this.mouse_delay?this._startMouseDelayTimer():void 0},t.prototype._startMouseDelayTimer=function(){return this._mouse_delay_timer&&clearTimeout(this._mouse_delay_timer),this._mouse_delay_timer=setTimeout(function(e){return function(){return e._is_mouse_delay_met=!0}}(this),this.mouse_delay),this._is_mouse_delay_met=!1},t.prototype._mouseMove=function(e){return this._handleMouseMove(e,this._getPositionInfo(e))},t.prototype._handleMouseMove=function(e,t){return this.is_mouse_started?(this._mouseDrag(t),e.preventDefault()):this.mouse_delay&&!this._is_mouse_delay_met?!0:(this.is_mouse_started=this._mouseStart(this.mouse_down_info)!==!1,this.is_mouse_started?this._mouseDrag(t):this._handleMouseUp(t),!this.is_mouse_started)},t.prototype._getPositionInfo=function(e){return{page_x:e.pageX,page_y:e.pageY,target:e.target,original_event:e}},t.prototype._mouseUp=function(e){return this._handleMouseUp(this._getPositionInfo(e))},t.prototype._handleMouseUp=function(e){var t;t=n(document),t.unbind("mousemove.mousewidget"),t.unbind("touchmove.mousewidget"),t.unbind("mouseup.mousewidget"),t.unbind("touchend.mousewidget"),this.is_mouse_started&&(this.is_mouse_started=!1,this._mouseStop(e))},t.prototype._mouseCapture=function(){return!0},t.prototype._mouseStart=function(){return null},t.prototype._mouseDrag=function(){return null},t.prototype._mouseStop=function(){return null},t.prototype.setMouseDelay=function(e){return this.mouse_delay=e},t.prototype._touchStart=function(e){var t;if(!(e.originalEvent.touches.length>1))return t=e.originalEvent.changedTouches[0],this._handleMouseDown(e,this._getPositionInfo(t))},t.prototype._touchMove=function(e){var t;if(!(e.originalEvent.touches.length>1))return t=e.originalEvent.changedTouches[0],this._handleMouseMove(e,this._getPositionInfo(t))},t.prototype._touchEnd=function(e){var t;if(!(e.originalEvent.touches.length>1))return t=e.originalEvent.changedTouches[0],this._handleMouseUp(this._getPositionInfo(t))},t}(r),t.exports=o},{"./simple.widget":10}],5:[function(e,t){var n,o,r;n=jQuery,r={getName:function(e){return r.strings[e-1]},nameToIndex:function(e){var t,n,o;for(t=n=1,o=r.strings.length;o>=1?o>=n:n>=o;t=o>=1?++n:--n)if(r.strings[t-1]===e)return t;return 0}},r.BEFORE=1,r.AFTER=2,r.INSIDE=3,r.NONE=4,r.strings=["before","after","inside","none"],o=function(){function e(t,n,o){null==n&&(n=!1),null==o&&(o=e),this.setData(t),this.children=[],this.parent=null,n&&(this.id_mapping={},this.tree=this,this.node_class=o)}return e.prototype.setData=function(e){var t,n;if("object"!=typeof e)this.name=e;else for(t in e)n=e[t],"label"===t?this.name=n:this[t]=n;return null},e.prototype.initFromData=function(e){var t,n;return n=function(e){return function(n){return e.setData(n),n.children?t(n.children):void 0}}(this),t=function(e){return function(t){var n,o,r,i;for(o=0,r=t.length;r>o;o++)n=t[o],i=new e.tree.node_class(""),i.initFromData(n),e.addChild(i);return null}}(this),n(e),null},e.prototype.loadFromData=function(e){var t,n,o,r;for(this.removeChildren(),t=0,n=e.length;n>t;t++)r=e[t],o=new this.tree.node_class(r),this.addChild(o),"object"==typeof r&&r.children&&o.loadFromData(r.children);return null},e.prototype.addChild=function(e){return this.children.push(e),e._setParent(this)},e.prototype.addChildAtPosition=function(e,t){return this.children.splice(t,0,e),e._setParent(this)},e.prototype._setParent=function(e){return this.parent=e,this.tree=e.tree,this.tree.addNodeToIndex(this)},e.prototype.removeChild=function(e){return e.removeChildren(),this._removeChild(e)},e.prototype._removeChild=function(e){return this.children.splice(this.getChildIndex(e),1),this.tree.removeNodeFromIndex(e)},e.prototype.getChildIndex=function(e){return n.inArray(e,this.children)},e.prototype.hasChildren=function(){return 0!==this.children.length},e.prototype.isFolder=function(){return this.hasChildren()||this.load_on_demand},e.prototype.iterate=function(e){var t;return t=function(n,o){var r,i,s,d,l;if(n.children){for(d=n.children,i=0,s=d.length;s>i;i++)r=d[i],l=e(r,o),l&&r.hasChildren()&&t(r,o+1);return null}},t(this,0),null},e.prototype.moveNode=function(e,t,n){return e.isParentOf(t)?void 0:(e.parent._removeChild(e),n===r.AFTER?t.parent.addChildAtPosition(e,t.parent.getChildIndex(t)+1):n===r.BEFORE?t.parent.addChildAtPosition(e,t.parent.getChildIndex(t)):n===r.INSIDE?t.addChildAtPosition(e,0):void 0)},e.prototype.getData=function(e){var t;return null==e&&(e=!1),(t=function(e){var n,o,r,i,s,d,l;for(n=[],o=0,i=e.length;i>o;o++){s=e[o],d={};for(r in s)l=s[r],"parent"!==r&&"children"!==r&&"element"!==r&&"tree"!==r&&Object.prototype.hasOwnProperty.call(s,r)&&(d[r]=l);s.hasChildren()&&(d.children=t(s.children)),n.push(d)}return n})(e?[this]:this.children)},e.prototype.getNodeByName=function(e){var t;return t=null,this.iterate(function(n){return n.name===e?(t=n,!1):!0}),t},e.prototype.addAfter=function(e){var t,n;return this.parent?(n=new this.tree.node_class(e),t=this.parent.getChildIndex(this),this.parent.addChildAtPosition(n,t+1),n):null},e.prototype.addBefore=function(e){var t,n;return this.parent?(n=new this.tree.node_class(e),t=this.parent.getChildIndex(this),this.parent.addChildAtPosition(n,t),n):null},e.prototype.addParent=function(e){var t,n,o,r,i,s;if(this.parent){for(r=new this.tree.node_class(e),r._setParent(this.tree),i=this.parent,s=i.children,n=0,o=s.length;o>n;n++)t=s[n],r.addChild(t);return i.children=[],i.addChild(r),r}return null},e.prototype.remove=function(){return this.parent?(this.parent.removeChild(this),this.parent=null):void 0},e.prototype.append=function(e){var t;return t=new this.tree.node_class(e),this.addChild(t),t},e.prototype.prepend=function(e){var t;return t=new this.tree.node_class(e),this.addChildAtPosition(t,0),t},e.prototype.isParentOf=function(e){var t;for(t=e.parent;t;){if(t===this)return!0;t=t.parent}return!1},e.prototype.getLevel=function(){var e,t;for(e=0,t=this;t.parent;)e+=1,t=t.parent;return e},e.prototype.getNodeById=function(e){return this.id_mapping[e]},e.prototype.addNodeToIndex=function(e){return null!=e.id?this.id_mapping[e.id]=e:void 0},e.prototype.removeNodeFromIndex=function(e){return null!=e.id?delete this.id_mapping[e.id]:void 0},e.prototype.removeChildren=function(){return this.iterate(function(e){return function(t){return e.tree.removeNodeFromIndex(t),!0}}(this)),this.children=[]},e.prototype.getPreviousSibling=function(){var e;return this.parent?(e=this.parent.getChildIndex(this)-1,e>=0?this.parent.children[e]:null):null},e.prototype.getNextSibling=function(){var e;return this.parent?(e=this.parent.getChildIndex(this)+1,e<this.parent.children.length?this.parent.children[e]:null):null},e.prototype.getNodesByProperty=function(e,t){return this.filter(function(n){return n[e]===t})},e.prototype.filter=function(e){var t;return t=[],this.iterate(function(n){return e(n)&&t.push(n),!0}),t},e.prototype.getNextNode=function(e){var t;return null==e&&(e=!0),e&&this.hasChildren()&&this.is_open?this.children[0]:this.parent?(t=this.getNextSibling(),t?t:this.parent.getNextNode(!1)):null},e.prototype.getPreviousNode=function(){var e;return this.parent?(e=this.getPreviousSibling(),e?e.hasChildren()&&e.is_open?e.getLastChild():e:this.parent.parent?this.parent:null):null},e.prototype.getLastChild=function(){var e;return this.hasChildren()?(e=this.children[this.children.length-1],e.hasChildren()&&e.is_open?e.getLastChild():e):null},e}(),t.exports={Node:o,Position:r}},{}],6:[function(e,t){var n,o,r,i,s,d,l,u=function(e,t){function n(){this.constructor=e}for(var o in t)a.call(t,o)&&(e[o]=t[o]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},a={}.hasOwnProperty;l=e("./node"),d=l.Position,n=jQuery,s=function(){function e(e,t){this.init(e,t)}return e.prototype.init=function(e,t){return this.node=e,this.tree_widget=t,e.element||(e.element=this.tree_widget.element),this.$element=n(e.element)},e.prototype.getUl=function(){return this.$element.children("ul:first")},e.prototype.getSpan=function(){return this.$element.children(".jqtree-element").find("span.jqtree-title")},e.prototype.getLi=function(){return this.$element},e.prototype.addDropHint=function(e){return e===d.INSIDE?new o(this.$element):new i(this.node,this.$element,e)},e.prototype.select=function(){return this.getLi().addClass("jqtree-selected")},e.prototype.deselect=function(){return this.getLi().removeClass("jqtree-selected")},e}(),r=function(e){function t(){return t.__super__.constructor.apply(this,arguments)}return u(t,e),t.prototype.open=function(e,t){var n,o;return null==t&&(t=!0),this.node.is_open?void 0:(this.node.is_open=!0,n=this.getButton(),n.removeClass("jqtree-closed"),n.html(""),n.append(this.tree_widget.renderer.opened_icon_element.cloneNode(!1)),o=function(t){return function(){return t.getLi().removeClass("jqtree-closed"),e&&e(),t.tree_widget._triggerEvent("tree.open",{node:t.node})}}(this),t?this.getUl().slideDown("fast",o):(this.getUl().show(),o()))},t.prototype.close=function(e){var t,n;return null==e&&(e=!0),this.node.is_open?(this.node.is_open=!1,t=this.getButton(),t.addClass("jqtree-closed"),t.html(""),t.append(this.tree_widget.renderer.closed_icon_element.cloneNode(!1)),n=function(e){return function(){return e.getLi().addClass("jqtree-closed"),e.tree_widget._triggerEvent("tree.close",{node:e.node})}}(this),e?this.getUl().slideUp("fast",n):(this.getUl().hide(),n())):void 0},t.prototype.getButton=function(){return this.$element.children(".jqtree-element").find("a.jqtree-toggler")},t.prototype.addDropHint=function(e){return this.node.is_open||e!==d.INSIDE?new i(this.node,this.$element,e):new o(this.$element)},t}(s),o=function(){function e(e){var t,o;t=e.children(".jqtree-element"),o=e.width()-4,this.$hint=n('<span class="jqtree-border"></span>'),t.append(this.$hint),this.$hint.css({width:o,height:t.outerHeight()-4})}return e.prototype.remove=function(){return this.$hint.remove()},e}(),i=function(){function e(e,t,o){this.$element=t,this.node=e,this.$ghost=n('<li class="jqtree_common jqtree-ghost"><span class="jqtree_common jqtree-circle"></span><span class="jqtree_common jqtree-line"></span></li>'),o===d.AFTER?this.moveAfter():o===d.BEFORE?this.moveBefore():o===d.INSIDE&&(e.isFolder()&&e.is_open?this.moveInsideOpenFolder():this.moveInside())}return e.prototype.remove=function(){return this.$ghost.remove()},e.prototype.moveAfter=function(){return this.$element.after(this.$ghost)},e.prototype.moveBefore=function(){return this.$element.before(this.$ghost)},e.prototype.moveInsideOpenFolder=function(){return n(this.node.children[0].element).before(this.$ghost)},e.prototype.moveInside=function(){return this.$element.after(this.$ghost),this.$ghost.addClass("jqtree-inside")},e}(),t.exports={FolderElement:r,NodeElement:s}},{"./node":5}],7:[function(e,t){var n,o,r,i,s;s=e("./util"),r=s.indexOf,i=s.isInt,n=jQuery,o=function(){function e(e){this.tree_widget=e}return e.prototype.saveState=function(){var e;return e=JSON.stringify(this.getState()),this.tree_widget.options.onSetStateFromStorage?this.tree_widget.options.onSetStateFromStorage(e):this.supportsLocalStorage()?localStorage.setItem(this.getCookieName(),e):n.cookie?(n.cookie.raw=!0,n.cookie(this.getCookieName(),e,{path:"/"})):void 0},e.prototype.getStateFromStorage=function(){var e;return e=this._loadFromStorage(),e?this._parseState(e):null},e.prototype._parseState=function(e){var t;return t=n.parseJSON(e),t&&t.selected_node&&i(t.selected_node)&&(t.selected_node=[t.selected_node]),t},e.prototype._loadFromStorage=function(){return this.tree_widget.options.onGetStateFromStorage?this.tree_widget.options.onGetStateFromStorage():this.supportsLocalStorage()?localStorage.getItem(this.getCookieName()):n.cookie?(n.cookie.raw=!0,n.cookie(this.getCookieName())):null},e.prototype.getState=function(){var e,t;return e=function(e){return function(){var t;return t=[],e.tree_widget.tree.iterate(function(e){return e.is_open&&e.id&&e.hasChildren()&&t.push(e.id),!0}),t}}(this),t=function(e){return function(){var t;return function(){var e,n,o,r;for(o=this.tree_widget.getSelectedNodes(),r=[],e=0,n=o.length;n>e;e++)t=o[e],r.push(t.id);return r}.call(e)}}(this),{open_nodes:e(),selected_node:t()}},e.prototype.setInitialState=function(e){var t;return e?(t=this._openInitialNodes(e.open_nodes),this._selectInitialNodes(e.selected_node),t):!1},e.prototype._openInitialNodes=function(e){var t,n,o,r,i;for(o=!1,t=0,n=e.length;n>t;t++)i=e[t],r=this.tree_widget.getNodeById(i),r&&(r.load_on_demand?o=!0:r.is_open=!0);return o},e.prototype._selectInitialNodes=function(e){var t,n,o,r,i;for(i=0,t=0,n=e.length;n>t;t++)r=e[t],o=this.tree_widget.getNodeById(r),o&&(i+=1,this.tree_widget.select_node_handler.addToSelection(o));return 0!==i},e.prototype.setInitialStateOnDemand=function(e){return e?this._setInitialStateOnDemand(e.open_nodes,e.selected_node):void 0},e.prototype._setInitialStateOnDemand=function(e,t){var n,o;return o=function(o){return function(){var r,i,s,d,l;for(s=[],r=0,i=e.length;i>r;r++)l=e[r],d=o.tree_widget.getNodeById(l),d?d.is_loading||(d.load_on_demand?n(d):o.tree_widget._openNode(d,!1)):s.push(l);return e=s,o._selectInitialNodes(t)?o.tree_widget._refreshElements():void 0}}(this),n=function(e){return function(t){return e.tree_widget._openNode(t,!1,o)}}(this),o()},e.prototype.getCookieName=function(){return"string"==typeof this.tree_widget.options.saveState?this.tree_widget.options.saveState:"tree"},e.prototype.supportsLocalStorage=function(){var e;return e=function(){var e,t;if("undefined"==typeof localStorage||null===localStorage)return!1;try{t="_storage_test",sessionStorage.setItem(t,!0),sessionStorage.removeItem(t)}catch(n){return e=n,!1}return!0},null==this._supportsLocalStorage&&(this._supportsLocalStorage=e()),this._supportsLocalStorage},e.prototype.getNodeIdToBeSelected=function(){var e;return e=this.getStateFromStorage(),e&&e.selected_node?e.selected_node[0]:null},e}(),t.exports=o},{"./util":12}],8:[function(e,t){var n,o;n=jQuery,o=function(){function e(e){this.tree_widget=e,this.previous_top=-1,this._initScrollParent()}return e.prototype._initScrollParent=function(){var e,t,o;return t=function(e){return function(){var t,o,r,i,s,d;if(t=["overflow","overflow-y"],(r=function(e){var o,r,i,s;for(r=0,i=t.length;i>r;r++)if(o=t[r],"auto"===(s=n.css(e,o))||"scroll"===s)return!0;return!1})(e.tree_widget.$el[0]))return e.tree_widget.$el;for(d=e.tree_widget.$el.parents(),i=0,s=d.length;s>i;i++)if(o=d[i],r(o))return n(o);return null}}(this),o=function(e){return function(){return e.scroll_parent_top=0,e.$scroll_parent=null}}(this),"fixed"===this.tree_widget.$el.css("position")&&o(),e=t(),e&&e.length&&"HTML"!==e[0].tagName?(this.$scroll_parent=e,this.scroll_parent_top=this.$scroll_parent.offset().top):o()},e.prototype.checkScrolling=function(){var e;return e=this.tree_widget.dnd_handler.hovered_area,e&&e.top!==this.previous_top?(this.previous_top=e.top,this.$scroll_parent?this._handleScrollingWithScrollParent(e):this._handleScrollingWithDocument(e)):void 0},e.prototype._handleScrollingWithScrollParent=function(e){var t;return t=this.scroll_parent_top+this.$scroll_parent[0].offsetHeight-e.bottom,20>t?(this.$scroll_parent[0].scrollTop+=20,this.tree_widget.refreshHitAreas(),this.previous_top=-1):e.top-this.scroll_parent_top<20?(this.$scroll_parent[0].scrollTop-=20,this.tree_widget.refreshHitAreas(),this.previous_top=-1):void 0},e.prototype._handleScrollingWithDocument=function(e){var t;return t=e.top-n(document).scrollTop(),20>t?n(document).scrollTop(n(document).scrollTop()-20):n(window).height()-(e.bottom-n(document).scrollTop())<20?n(document).scrollTop(n(document).scrollTop()+20):void 0},e.prototype.scrollTo=function(e){var t;return this.$scroll_parent?this.$scroll_parent[0].scrollTop=e:(t=this.tree_widget.$el.offset().top,n(document).scrollTop(e+t))},e.prototype.isScrolledIntoView=function(e){var t,o,r,i,s;return t=n(e),this.$scroll_parent?(s=0,i=this.$scroll_parent.height(),r=t.offset().top-this.scroll_parent_top,o=r+t.height()):(s=n(window).scrollTop(),i=s+n(window).height(),r=t.offset().top,o=r+t.height()),i>=o&&r>=s},e}(),t.exports=o},{}],9:[function(e,t){var n,o;n=jQuery,o=function(){function e(e){this.tree_widget=e,this.clear()}return e.prototype.getSelectedNode=function(){var e;return e=this.getSelectedNodes(),e.length?e[0]:!1},e.prototype.getSelectedNodes=function(){var e,t,n;if(this.selected_single_node)return[this.selected_single_node];n=[];for(e in this.selected_nodes)t=this.tree_widget.getNodeById(e),t&&n.push(t);return n},e.prototype.getSelectedNodesUnder=function(e){var t,n,o;if(this.selected_single_node)return e.isParentOf(this.selected_single_node)?[this.selected_single_node]:[];o=[];for(t in this.selected_nodes)n=this.tree_widget.getNodeById(t),n&&e.isParentOf(n)&&o.push(n);return o},e.prototype.isNodeSelected=function(e){return e.id?this.selected_nodes[e.id]:this.selected_single_node?this.selected_single_node.element===e.element:!1},e.prototype.clear=function(){return this.selected_nodes={},this.selected_single_node=null},e.prototype.removeFromSelection=function(e,t){if(null==t&&(t=!1),e.id){if(delete this.selected_nodes[e.id],t)return e.iterate(function(t){return function(){return delete t.selected_nodes[e.id],!0}}(this))}else if(this.selected_single_node&&e.element===this.selected_single_node.element)return this.selected_single_node=null},e.prototype.addToSelection=function(e){return e.id?this.selected_nodes[e.id]=!0:this.selected_single_node=e
},e}(),t.exports=o},{}],10:[function(e,t){var n,o,r=[].slice;n=jQuery,o=function(){function e(e,t){this.$el=n(e),this.options=n.extend({},this.defaults,t)}return e.prototype.defaults={},e.prototype.destroy=function(){return this._deinit()},e.prototype._init=function(){return null},e.prototype._deinit=function(){return null},e.register=function(t,o){var i,s,d,l,u;return l=function(){return"simple_widget_"+o},u=function(t,o){var r;return r=n.data(t,o),r&&r instanceof e?r:null},s=function(e,o){var r,i,s,d,a,h;for(r=l(),d=0,a=e.length;a>d;d++)i=e[d],s=u(i,r),s||(h=new t(i,o),n.data(i,r)||n.data(i,r,h),h._init());return e},d=function(e){var t,o,r,i,s,d;for(t=l(),s=[],r=0,i=e.length;i>r;r++)o=e[r],d=u(o,t),d&&d.destroy(),s.push(n.removeData(o,t));return s},i=function(t,o,r){var i,s,d,u,a,h;for(u=null,s=0,d=t.length;d>s;s++)i=t[s],a=n.data(i,l()),a&&a instanceof e&&(h=a[o],h&&"function"==typeof h&&(u=h.apply(a,r)));return u},n.fn[o]=function(){var e,n,o,l,u;return o=arguments[0],n=2<=arguments.length?r.call(arguments,1):[],e=this,void 0===o||"object"==typeof o?(u=o,s(e,u)):"string"==typeof o&&"_"!==o[0]?(l=o,"destroy"===l?d(e):"get_widget_class"===l?t:i(e,l,n)):void 0}},e}(),t.exports=o},{}],11:[function(e){var t,n,o,r,i,s,d,l,u,a,h,p,c,_,f,m,g,v,y=function(e,t){function n(){this.constructor=e}for(var o in t)N.call(t,o)&&(e[o]=t[o]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},N={}.hasOwnProperty;f=e("./version"),n=e("./drag_and_drop_handler"),o=e("./elements_renderer"),s=e("./key_handler"),d=e("./mouse.widget"),h=e("./save_state_handler"),p=e("./scroll_handler"),c=e("./select_node_handler"),_=e("./simple.widget"),g=e("./node"),l=g.Node,a=g.Position,v=e("./util"),m=e("./node_element"),u=m.NodeElement,r=m.FolderElement,t=jQuery,i=function(e){function i(){return i.__super__.constructor.apply(this,arguments)}return y(i,e),i.prototype.defaults={autoOpen:!1,saveState:!1,dragAndDrop:!1,selectable:!0,useContextMenu:!0,onCanSelectNode:null,onSetStateFromStorage:null,onGetStateFromStorage:null,onCreateLi:null,onIsMoveHandle:null,onCanMove:null,onCanMoveTo:null,onLoadFailed:null,autoEscape:!0,dataUrl:null,closedIcon:null,openedIcon:"&#x25bc;",slide:!0,nodeClass:l,dataFilter:null,keyboardSupport:!0,openFolderDelay:500,rtl:null},i.prototype.toggle=function(e,t){return null==t&&(t=null),null===t&&(t=this.options.slide),e.is_open?this.closeNode(e,t):this.openNode(e,t)},i.prototype.getTree=function(){return this.tree},i.prototype.selectNode=function(e){return this._selectNode(e,!1)},i.prototype._selectNode=function(e,t){var n,o,r,i;if(null==t&&(t=!1),this.select_node_handler){if(n=function(t){return function(){return t.options.onCanSelectNode?t.options.selectable&&t.options.onCanSelectNode(e):t.options.selectable}}(this),r=function(t){return function(){var n;return n=e.parent,n&&n.parent&&!n.is_open?t.openNode(n,!1):void 0}}(this),i=function(e){return function(){return e.options.saveState?e.save_state_handler.saveState():void 0}}(this),!e)return this._deselectCurrentNode(),void i();if(n())return this.select_node_handler.isNodeSelected(e)?t&&(this._deselectCurrentNode(),this._triggerEvent("tree.select",{node:null,previous_node:e})):(o=this.getSelectedNode(),this._deselectCurrentNode(),this.addToSelection(e),this._triggerEvent("tree.select",{node:e,deselected_node:o}),r()),i()}},i.prototype.getSelectedNode=function(){return this.select_node_handler?this.select_node_handler.getSelectedNode():null},i.prototype.toJson=function(){return JSON.stringify(this.tree.getData())},i.prototype.loadData=function(e,t){return this._loadData(e,t)},i.prototype.loadDataFromUrl=function(e,n,o){return"string"!==t.type(e)&&(o=n,n=e,e=null),this._loadDataFromUrl(e,n,o)},i.prototype.reload=function(){return this.loadDataFromUrl()},i.prototype._loadDataFromUrl=function(e,n,o){var r,i,s,d,l,u;if(r=null,i=function(e){return function(){return r=n?t(n.element):e.element,r.addClass("jqtree-loading")}}(this),u=function(){return r?r.removeClass("jqtree-loading"):void 0},l=function(){return"string"===t.type(e)&&(e={url:e}),e.method?void 0:e.method="get"},s=function(e){return function(r){return u(),e._loadData(r,n),o&&t.isFunction(o)?o():void 0}}(this),d=function(n){return function(){return l(),t.ajax({url:e.url,data:e.data,type:e.method.toUpperCase(),cache:!1,dataType:"json",success:function(e){var o;return o=t.isArray(e)||"object"==typeof e?e:t.parseJSON(e),n.options.dataFilter&&(o=n.options.dataFilter(o)),s(o)},error:function(e){return u(),n.options.onLoadFailed?n.options.onLoadFailed(e):void 0}})}}(this),e||(e=this._getDataUrlInfo(n)),i(),e){if(!t.isArray(e))return d();s(e)}else u()},i.prototype._loadData=function(e,t){var n,o;return null==t&&(t=null),n=function(e){return function(){var n,o,r,i;if(e.select_node_handler)for(i=e.select_node_handler.getSelectedNodesUnder(t),n=0,o=i.length;o>n;n++)r=i[n],e.select_node_handler.removeFromSelection(r);return null}}(this),o=function(n){return function(){return t.loadFromData(e),t.load_on_demand=!1,t.is_loading=!1,n._refreshElements(t)}}(this),e?(this._triggerEvent("tree.load_data",{tree_data:e}),t?(n(),o()):this._initTree(e),this.isDragging()?this.dnd_handler.refresh():void 0):void 0},i.prototype.getNodeById=function(e){return this.tree.getNodeById(e)},i.prototype.getNodeByName=function(e){return this.tree.getNodeByName(e)},i.prototype.getNodesByProperty=function(e,t){return this.tree.getNodesByProperty(e,t)},i.prototype.openNode=function(e,t){return null==t&&(t=null),null===t&&(t=this.options.slide),this._openNode(e,t)},i.prototype._openNode=function(e,t,n){var o,i;if(null==t&&(t=!0),o=function(e){return function(t,n,o){var i;return i=new r(t,e),i.open(o,n)}}(this),e.isFolder()){if(e.load_on_demand)return this._loadFolderOnDemand(e,t,n);for(i=e.parent;i;)i.parent&&o(i,!1,null),i=i.parent;return o(e,t,n),this._saveState()}},i.prototype._loadFolderOnDemand=function(e,t,n){return null==t&&(t=!0),e.is_loading=!0,this._loadDataFromUrl(null,e,function(o){return function(){return o._openNode(e,t,n)}}(this))},i.prototype.closeNode=function(e,t){return null==t&&(t=null),null===t&&(t=this.options.slide),e.isFolder()?(new r(e,this).close(t),this._saveState()):void 0},i.prototype.isDragging=function(){return this.dnd_handler?this.dnd_handler.is_dragging:!1},i.prototype.refreshHitAreas=function(){return this.dnd_handler.refresh()},i.prototype.addNodeAfter=function(e,t){var n;return n=t.addAfter(e),this._refreshElements(t.parent),n},i.prototype.addNodeBefore=function(e,t){var n;return n=t.addBefore(e),this._refreshElements(t.parent),n},i.prototype.addParentNode=function(e,t){var n;return n=t.addParent(e),this._refreshElements(n.parent),n},i.prototype.removeNode=function(e){var t;return t=e.parent,t?(this.select_node_handler.removeFromSelection(e,!0),e.remove(),this._refreshElements(t)):void 0},i.prototype.appendNode=function(e,t){var n;return t=t||this.tree,n=t.append(e),this._refreshElements(t),n},i.prototype.prependNode=function(e,t){var n;return t||(t=this.tree),n=t.prepend(e),this._refreshElements(t),n},i.prototype.updateNode=function(e,t){var n;return n=t.id&&t.id!==e.id,n&&this.tree.removeNodeFromIndex(e),e.setData(t),n&&this.tree.addNodeToIndex(e),this.renderer.renderFromNode(e),this._selectCurrentNode()},i.prototype.moveNode=function(e,t,n){var o;return o=a.nameToIndex(n),this.tree.moveNode(e,t,o),this._refreshElements()},i.prototype.getStateFromStorage=function(){return this.save_state_handler.getStateFromStorage()},i.prototype.addToSelection=function(e){return e?(this.select_node_handler.addToSelection(e),this._getNodeElementForNode(e).select(),this._saveState()):void 0},i.prototype.getSelectedNodes=function(){return this.select_node_handler.getSelectedNodes()},i.prototype.isNodeSelected=function(e){return this.select_node_handler.isNodeSelected(e)},i.prototype.removeFromSelection=function(e){return this.select_node_handler.removeFromSelection(e),this._getNodeElementForNode(e).deselect(),this._saveState()},i.prototype.scrollToNode=function(e){var n,o;return n=t(e.element),o=n.offset().top-this.$el.offset().top,this.scroll_handler.scrollTo(o)},i.prototype.getState=function(){return this.save_state_handler.getState()},i.prototype.setState=function(e){return this.save_state_handler.setInitialState(e),this._refreshElements()},i.prototype.setOption=function(e,t){return this.options[e]=t},i.prototype.moveDown=function(){return this.key_handler?this.key_handler.moveDown():void 0},i.prototype.moveUp=function(){return this.key_handler?this.key_handler.moveUp():void 0},i.prototype.getVersion=function(){return f},i.prototype._init=function(){return i.__super__._init.call(this),this.element=this.$el,this.mouse_delay=300,this.is_initialized=!1,this.options.rtl=this._getRtlOption(),this.options.closedIcon||(this.options.closedIcon=this._getDefaultClosedIcon()),this.renderer=new o(this),null!=h?this.save_state_handler=new h(this):this.options.saveState=!1,null!=c&&(this.select_node_handler=new c(this)),null!=n?this.dnd_handler=new n(this):this.options.dragAndDrop=!1,null!=p&&(this.scroll_handler=new p(this)),null!=s&&null!=c&&(this.key_handler=new s(this)),this._initData(),this.element.click(t.proxy(this._click,this)),this.element.dblclick(t.proxy(this._dblclick,this)),this.options.useContextMenu?this.element.bind("contextmenu",t.proxy(this._contextmenu,this)):void 0},i.prototype._deinit=function(){return this.element.empty(),this.element.unbind(),this.key_handler&&this.key_handler.deinit(),this.tree=null,i.__super__._deinit.call(this)},i.prototype._initData=function(){return this.options.data?this._loadData(this.options.data):this._loadDataFromUrl(this._getDataUrlInfo())},i.prototype._getDataUrlInfo=function(e){var n,o;return n=this.options.dataUrl||this.element.data("url"),o=function(t){return function(){var o,r,i;return i={url:n},e&&e.id?(o={node:e.id},i.data=o):(r=t._getNodeIdToBeSelected(),r&&(o={selected_node:r},i.data=o)),i}}(this),t.isFunction(n)?n(e):"string"===t.type(n)?o():n},i.prototype._getNodeIdToBeSelected=function(){return this.options.saveState?this.save_state_handler.getNodeIdToBeSelected():null},i.prototype._initTree=function(e){var t;return this.tree=new this.options.nodeClass(null,!0,this.options.nodeClass),this.select_node_handler&&this.select_node_handler.clear(),this.tree.loadFromData(e),t=this._setInitialState(),this._refreshElements(),t&&this._setInitialStateOnDemand(),this.is_initialized?void 0:(this.is_initialized=!0,this._triggerEvent("tree.init"))},i.prototype._setInitialState=function(){var e,t,n,o,r;return r=function(e){return function(){var t,n;return e.options.saveState&&e.save_state_handler?(n=e.save_state_handler.getStateFromStorage(),n?(t=e.save_state_handler.setInitialState(n),[!0,t]):[!1,!1]):[!1,!1]}}(this),e=function(e){return function(){var t,n;return e.options.autoOpen===!1?!1:(t=e._getAutoOpenMaxLevel(),n=!1,e.tree.iterate(function(e,o){return e.load_on_demand?(n=!0,!1):e.hasChildren()?(e.is_open=!0,o!==t):!1}),n)}}(this),o=r(),t=o[0],n=o[1],t||(n=e()),n},i.prototype._setInitialStateOnDemand=function(){var e,t;return t=function(e){return function(){var t;return e.options.saveState&&e.save_state_handler?(t=e.save_state_handler.getStateFromStorage(),t?(e.save_state_handler.setInitialStateOnDemand(t),!0):!1):!1}}(this),e=function(e){return function(){var t,n,o,r;return o=e._getAutoOpenMaxLevel(),n=[],t=function(t){return e._openNode(t,!1,r)},(r=function(){return e.tree.iterate(function(n,r){return n.load_on_demand?(n.is_loading||t(n),!1):(e._openNode(n,!1),r!==o)})})()}}(this),t()?void 0:e()},i.prototype._getAutoOpenMaxLevel=function(){return this.options.autoOpen===!0?-1:parseInt(this.options.autoOpen)},i.prototype._refreshElements=function(e){return null==e&&(e=null),this.renderer.render(e),this._triggerEvent("tree.refresh")},i.prototype._click=function(e){var t,n,o;if(t=this._getClickTarget(e.target)){if("button"===t.type)return this.toggle(t.node,this.options.slide),e.preventDefault(),e.stopPropagation();if("label"===t.type&&(o=t.node,n=this._triggerEvent("tree.click",{node:o,click_event:e}),!n.isDefaultPrevented()))return this._selectNode(o,!0)}},i.prototype._dblclick=function(e){var t;return t=this._getClickTarget(e.target),t&&"label"===t.type?this._triggerEvent("tree.dblclick",{node:t.node,click_event:e}):void 0},i.prototype._getClickTarget=function(e){var n,o,r,i;if(r=t(e),n=r.closest(".jqtree-toggler"),n.length){if(i=this._getNode(n))return{type:"button",node:i}}else if(o=r.closest(".jqtree-element"),o.length&&(i=this._getNode(o)))return{type:"label",node:i};return null},i.prototype._getNode=function(e){var t;return t=e.closest("li.jqtree_common"),0===t.length?null:t.data("node")},i.prototype._getNodeElementForNode=function(e){return e.isFolder()?new r(e,this):new u(e,this)},i.prototype._getNodeElement=function(e){var t;return t=this._getNode(e),t?this._getNodeElementForNode(t):null},i.prototype._contextmenu=function(e){var n,o;return n=t(e.target).closest("ul.jqtree-tree .jqtree-element"),n.length&&(o=this._getNode(n))?(e.preventDefault(),e.stopPropagation(),this._triggerEvent("tree.contextmenu",{node:o,click_event:e}),!1):void 0},i.prototype._saveState=function(){return this.options.saveState?this.save_state_handler.saveState():void 0},i.prototype._mouseCapture=function(e){return this.options.dragAndDrop?this.dnd_handler.mouseCapture(e):!1},i.prototype._mouseStart=function(e){return this.options.dragAndDrop?this.dnd_handler.mouseStart(e):!1},i.prototype._mouseDrag=function(e){var t;return this.options.dragAndDrop?(t=this.dnd_handler.mouseDrag(e),this.scroll_handler&&this.scroll_handler.checkScrolling(),t):!1},i.prototype._mouseStop=function(e){return this.options.dragAndDrop?this.dnd_handler.mouseStop(e):!1},i.prototype._triggerEvent=function(e,n){var o;return o=t.Event(e),t.extend(o,n),this.element.trigger(o),o},i.prototype.testGenerateHitAreas=function(e){return this.dnd_handler.current_item=this._getNodeElementForNode(e),this.dnd_handler.generateHitAreas(),this.dnd_handler.hit_areas},i.prototype._selectCurrentNode=function(){var e;return e=this.getSelectedNode(),e&&(m=this._getNodeElementForNode(e))?m.select():void 0},i.prototype._deselectCurrentNode=function(){var e;return e=this.getSelectedNode(),e?this.removeFromSelection(e):void 0},i.prototype._getDefaultClosedIcon=function(){return this.options.rtl?"&#x25c0;":"&#x25ba;"},i.prototype._getRtlOption=function(){var e;return null!==this.options.rtl?this.options.rtl:(e=this.element.data("rtl"),null!=e&&e!==!1?!0:!1)},i}(d),i.getModule=function(e){var t;return t={node:g,util:v},t[e]},_.register(i,"tree")},{"./drag_and_drop_handler":1,"./elements_renderer":2,"./key_handler":3,"./mouse.widget":4,"./node":5,"./node_element":6,"./save_state_handler":7,"./scroll_handler":8,"./select_node_handler":9,"./simple.widget":10,"./util":12,"./version":13}],12:[function(e,t){var n,o,r,i;n=function(e,t){var n,o,r,i;for(n=o=0,r=e.length;r>o;n=++o)if(i=e[n],i===t)return n;return-1},r=function(e,t){return e.indexOf?e.indexOf(t):n(e,t)},i=function(e){return"number"==typeof e&&e%1===0},o=function(e){return(""+e).replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;").replace(/\//g,"&#x2F;")},t.exports={_indexOf:n,html_escape:o,indexOf:r,isInt:i}},{}],13:[function(e,t){t.exports="1.2.1"},{}]},{},[11]);